diff --git a/gcc/tree-sra.c b/gcc/tree-sra.c
index 284d544..c9a8ae2 100644
--- a/gcc/tree-sra.c
+++ b/gcc/tree-sra.c
@@ -3482,7 +3482,7 @@ late_intra_sra (void)
 static bool
 gate_intra_sra (void)
 {
-  return flag_tree_sra != 0 && dbg_cnt (tree_sra);
+  return GCC_OPTION (flag_tree_sra) != 0 && dbg_cnt (tree_sra);
 }
 
 
@@ -5033,7 +5033,7 @@ ipa_early_sra (void)
 static bool
 ipa_early_sra_gate (void)
 {
-  return flag_ipa_sra && dbg_cnt (eipa_sra);
+  return GCC_OPTION (flag_ipa_sra) && dbg_cnt (eipa_sra);
 }
 
 namespace {
diff --git a/gcc/tree-ssa-alias.c b/gcc/tree-ssa-alias.c
index e706275..33b3eca 100644
--- a/gcc/tree-ssa-alias.c
+++ b/gcc/tree-ssa-alias.c
@@ -943,7 +943,7 @@ indirect_ref_may_alias_decl_p (tree ref1 ATTRIBUTE_UNUSED, tree base1,
     return false;
 
   /* Disambiguations that rely on strict aliasing rules follow.  */
-  if (!flag_strict_aliasing || !tbaa_p)
+  if (!GCC_OPTION (flag_strict_aliasing) || !tbaa_p)
     return true;
 
   ptrtype1 = TREE_TYPE (TREE_OPERAND (base1, 1));
@@ -1110,7 +1110,7 @@ indirect_refs_may_alias_p (tree ref1 ATTRIBUTE_UNUSED, tree base1,
     return false;
 
   /* Disambiguations that rely on strict aliasing rules follow.  */
-  if (!flag_strict_aliasing || !tbaa_p)
+  if (!GCC_OPTION (flag_strict_aliasing) || !tbaa_p)
     return true;
 
   ptrtype1 = TREE_TYPE (TREE_OPERAND (base1, 1));
@@ -1254,7 +1254,7 @@ refs_may_alias_p_1 (ao_ref *ref1, ao_ref *ref2, bool tbaa_p)
 
   /* First defer to TBAA if possible.  */
   if (tbaa_p
-      && flag_strict_aliasing
+      && GCC_OPTION (flag_strict_aliasing)
       && !alias_sets_conflict_p (ao_ref_alias_set (ref1),
 				 ao_ref_alias_set (ref2)))
     return false;
@@ -1830,7 +1830,7 @@ call_may_clobber_ref_p_1 (gimple call, ao_ref *ref)
 	case BUILT_IN_STRDUP:
 	case BUILT_IN_STRNDUP:
 	  /* Unix98 specifies that errno is set on allocation failure.  */
-	  if (flag_errno_math
+	  if (GCC_OPTION (flag_errno_math)
 	      && targetm.ref_may_alias_errno (ref))
 	    return true;
 	  return false;
@@ -1848,7 +1848,7 @@ call_may_clobber_ref_p_1 (gimple call, ao_ref *ref)
 	    ao_ref_init_from_ptr_and_size (&dref, ptrptr,
 					   TYPE_SIZE_UNIT (ptr_type_node));
 	    return (refs_may_alias_p_1 (&dref, ref, false)
-		    || (flag_errno_math
+		    || (GCC_OPTION (flag_errno_math)
 			&& targetm.ref_may_alias_errno (ref)));
 	  }
 	/* Freeing memory kills the pointed-to memory.  More importantly
@@ -1870,7 +1870,7 @@ call_may_clobber_ref_p_1 (gimple call, ao_ref *ref)
 	    tree out = gimple_call_arg (call, 1);
 	    if (ptr_deref_may_alias_ref_p_1 (out, ref))
 	      return true;
-	    if (flag_errno_math)
+	    if (GCC_OPTION (flag_errno_math))
 	      break;
 	    return false;
 	  }
@@ -1891,7 +1891,7 @@ call_may_clobber_ref_p_1 (gimple call, ao_ref *ref)
 	    tree out = gimple_call_arg (call, 2);
 	    if (ptr_deref_may_alias_ref_p_1 (out, ref))
 	      return true;
-	    if (flag_errno_math)
+	    if (GCC_OPTION (flag_errno_math))
 	      break;
 	    return false;
 	  }
diff --git a/gcc/tree-ssa-ccp.c b/gcc/tree-ssa-ccp.c
index eeefeaf..48a56ab 100644
--- a/gcc/tree-ssa-ccp.c
+++ b/gcc/tree-ssa-ccp.c
@@ -270,7 +270,7 @@ get_default_value (tree var)
 	{
 	  val.lattice_val = VARYING;
 	  val.mask = double_int_minus_one;
-	  if (flag_tree_bit_ccp)
+	  if (GCC_OPTION (flag_tree_bit_ccp))
 	    {
 	      double_int nonzero_bits = get_nonzero_bits (var);
 	      double_int mask
@@ -1665,7 +1665,7 @@ evaluate_stmt (gimple stmt)
     }
 
   /* Resort to simplification for bitwise tracking.  */
-  if (flag_tree_bit_ccp
+  if (GCC_OPTION (flag_tree_bit_ccp)
       && (likelyvalue == CONSTANT || is_gimple_call (stmt))
       && !is_constant)
     {
@@ -1783,7 +1783,7 @@ evaluate_stmt (gimple stmt)
       is_constant = (val.lattice_val == CONSTANT);
     }
 
-  if (flag_tree_bit_ccp
+  if (GCC_OPTION (flag_tree_bit_ccp)
       && ((is_constant && TREE_CODE (val.value) == INTEGER_CST)
 	  || (!is_constant && likelyvalue != UNDEFINED))
       && gimple_get_lhs (stmt)
@@ -2290,7 +2290,7 @@ do_ssa_ccp (void)
 static bool
 gate_ccp (void)
 {
-  return flag_tree_ccp != 0;
+  return GCC_OPTION (flag_tree_ccp) != 0;
 }
 
 
diff --git a/gcc/tree-ssa-coalesce.c b/gcc/tree-ssa-coalesce.c
index 9a1ac67..2ccc876 100644
--- a/gcc/tree-ssa-coalesce.c
+++ b/gcc/tree-ssa-coalesce.c
@@ -1265,7 +1265,7 @@ coalesce_ssa_name (void)
 
   /* If optimization is disabled, we need to coalesce all the names originating
      from the same SSA_NAME_VAR so debug info remains undisturbed.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     {
       hash_table <ssa_name_var_hash> ssa_name_hash;
 
@@ -1294,7 +1294,7 @@ coalesce_ssa_name (void)
 		     originally with optimizations and only the link
 		     performed at -O0, so we can't actually require it.  */
 		  const int cost
-		    = (TREE_CODE (SSA_NAME_VAR (a)) == VAR_DECL || in_lto_p)
+		    = (TREE_CODE (SSA_NAME_VAR (a)) == VAR_DECL || GCC_OPTION (in_lto_p))
 		      ? MUST_COALESCE_COST - 1 : MUST_COALESCE_COST;
 		  add_coalesce (cl, SSA_NAME_VERSION (a),
 				SSA_NAME_VERSION (*slot), cost);
diff --git a/gcc/tree-ssa-copy.c b/gcc/tree-ssa-copy.c
index 02f4743..a18ca53 100644
--- a/gcc/tree-ssa-copy.c
+++ b/gcc/tree-ssa-copy.c
@@ -647,7 +647,7 @@ execute_copy_prop (void)
 static bool
 gate_copy_prop (void)
 {
-  return flag_tree_copy_prop != 0;
+  return GCC_OPTION (flag_tree_copy_prop) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-copyrename.c b/gcc/tree-ssa-copyrename.c
index bc947b6..400ffda 100644
--- a/gcc/tree-ssa-copyrename.c
+++ b/gcc/tree-ssa-copyrename.c
@@ -206,11 +206,11 @@ copy_rename_partition_coalesce (var_map map, tree var1, tree var2, FILE *debug)
   /* Refrain from coalescing user variables, if requested.  */
   if (!ign1 && !ign2)
     {
-      if (flag_ssa_coalesce_vars && DECL_FROM_INLINE (root2))
+      if (GCC_OPTION (flag_ssa_coalesce_vars) && DECL_FROM_INLINE (root2))
 	ign2 = true;
-      else if (flag_ssa_coalesce_vars && DECL_FROM_INLINE (root1))
+      else if (GCC_OPTION (flag_ssa_coalesce_vars) && DECL_FROM_INLINE (root1))
 	ign1 = true;
-      else if (flag_ssa_coalesce_vars != 2)
+      else if (GCC_OPTION (flag_ssa_coalesce_vars) != 2)
 	{
 	  if (debug)
 	    fprintf (debug, " : 2 different USER vars. No coalesce.\n");
@@ -440,7 +440,7 @@ rename_ssa_copies (void)
 static bool
 gate_copyrename (void)
 {
-  return flag_tree_copyrename != 0;
+  return GCC_OPTION (flag_tree_copyrename) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-dce.c b/gcc/tree-ssa-dce.c
index 13a71ce..384900a 100644
--- a/gcc/tree-ssa-dce.c
+++ b/gcc/tree-ssa-dce.c
@@ -1501,13 +1501,13 @@ tree_ssa_dce_loop (void)
 static unsigned int
 tree_ssa_cd_dce (void)
 {
-  return perform_tree_ssa_dce (/*aggressive=*/optimize >= 2);
+  return perform_tree_ssa_dce (/*aggressive=*/GCC_OPTION (optimize) >= 2);
 }
 
 static bool
 gate_dce (void)
 {
-  return flag_tree_dce != 0;
+  return GCC_OPTION (flag_tree_dce) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-dom.c b/gcc/tree-ssa-dom.c
index 91253dc..2f821b0 100644
--- a/gcc/tree-ssa-dom.c
+++ b/gcc/tree-ssa-dom.c
@@ -955,7 +955,7 @@ tree_ssa_dominator_optimize (void)
 static bool
 gate_dominator (void)
 {
-  return flag_tree_dom != 0;
+  return GCC_OPTION (flag_tree_dom) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-dse.c b/gcc/tree-ssa-dse.c
index 2c2f3f7..c88df78 100644
--- a/gcc/tree-ssa-dse.c
+++ b/gcc/tree-ssa-dse.c
@@ -366,7 +366,7 @@ tree_ssa_dse (void)
 static bool
 gate_dse (void)
 {
-  return flag_tree_dse != 0;
+  return GCC_OPTION (flag_tree_dse) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-forwprop.c b/gcc/tree-ssa-forwprop.c
index b229429..7f7df51 100644
--- a/gcc/tree-ssa-forwprop.c
+++ b/gcc/tree-ssa-forwprop.c
@@ -3840,7 +3840,7 @@ ssa_forward_propagate_and_combine (void)
 static bool
 gate_forwprop (void)
 {
-  return flag_tree_forwprop;
+  return GCC_OPTION (flag_tree_forwprop);
 }
 
 namespace {
diff --git a/gcc/tree-ssa-live.c b/gcc/tree-ssa-live.c
index 3cd3613..7dbfd3f 100644
--- a/gcc/tree-ssa-live.c
+++ b/gcc/tree-ssa-live.c
@@ -556,8 +556,8 @@ remove_unused_scope_block_p (tree scope)
 	 information is being generated.  */
 
       else if (TREE_CODE (*t) == TYPE_DECL
-	       || debug_info_level == DINFO_LEVEL_NORMAL
-	       || debug_info_level == DINFO_LEVEL_VERBOSE)
+	       || GCC_OPTION (debug_info_level) == DINFO_LEVEL_NORMAL
+	       || GCC_OPTION (debug_info_level) == DINFO_LEVEL_VERBOSE)
 	;
       else
 	{
@@ -607,7 +607,7 @@ remove_unused_scope_block_p (tree scope)
      ;
    /* When not generating debug info we can eliminate info on unused
       variables.  */
-   else if (debug_info_level == DINFO_LEVEL_NONE)
+   else if (GCC_OPTION (debug_info_level) == DINFO_LEVEL_NONE)
      {
        /* Even for -g0 don't prune outer scopes from artificial
 	  functions, otherwise diagnostics using tree_nonartificial_location
@@ -782,7 +782,7 @@ remove_unused_locals (void)
   /* Removing declarations from lexical blocks when not optimizing is
      not only a waste of time, it actually causes differences in stack
      layout.  */
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return;
 
   timevar_push (TV_REMOVE_UNUSED);
diff --git a/gcc/tree-ssa-loop-ch.c b/gcc/tree-ssa-loop-ch.c
index 0a6b1c1..9d0f8f9 100644
--- a/gcc/tree-ssa-loop-ch.c
+++ b/gcc/tree-ssa-loop-ch.c
@@ -218,7 +218,7 @@ copy_loop_headers (void)
 	 about that case for -Wstrict-overflow, because in general we
 	 don't warn about overflow involving loops.  Prevent the
 	 warning by setting the no_warning flag in the condition.  */
-      if (warn_strict_overflow > 0)
+      if (GCC_OPTION (warn_strict_overflow) > 0)
 	{
 	  unsigned int i;
 
@@ -260,7 +260,7 @@ copy_loop_headers (void)
 static bool
 gate_ch (void)
 {
-  return flag_tree_ch != 0;
+  return GCC_OPTION (flag_tree_ch) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-loop-im.c b/gcc/tree-ssa-loop-im.c
index c75f257..525b6d4 100644
--- a/gcc/tree-ssa-loop-im.c
+++ b/gcc/tree-ssa-loop-im.c
@@ -285,7 +285,7 @@ movement_possibility (gimple stmt)
   tree lhs;
   enum move_pos ret = MOVE_POSSIBLE;
 
-  if (flag_unswitch_loops
+  if (GCC_OPTION (flag_unswitch_loops)
       && gimple_code (stmt) == GIMPLE_COND)
     {
       /* If we perform unswitching, force the operands of the invariant
@@ -350,7 +350,7 @@ movement_possibility (gimple stmt)
   /* Non local loads in a transaction cannot be hoisted out.  Well,
      unless the load happens on every path out of the loop, but we
      don't take this into account yet.  */
-  if (flag_tm
+  if (GCC_OPTION (flag_tm)
       && gimple_in_transaction (stmt)
       && gimple_assign_single_p (stmt))
     {
@@ -1083,8 +1083,8 @@ invariantness_dom_walker::before_dom_children (basic_block bb)
 	     to be hoisted out of loop, saving expensive divide.  */
 	  if (pos == MOVE_POSSIBLE
 	      && gimple_assign_rhs_code (stmt) == RDIV_EXPR
-	      && flag_unsafe_math_optimizations
-	      && !flag_trapping_math
+	      && GCC_OPTION (flag_unsafe_math_optimizations)
+	      && !GCC_OPTION (flag_trapping_math)
 	      && ol1 != NULL
 	      && outermost_invariant_loop (op0, ol1) == NULL)
 	    stmt = rewrite_reciprocal (&bsi);
@@ -1619,7 +1619,7 @@ mem_refs_may_alias_p (mem_ref_p mem1, mem_ref_p mem2,
 
   /* The expansion of addresses may be a bit expensive, thus we only do
      the check at -O2 and higher optimization levels.  */
-  if (optimize < 2)
+  if (GCC_OPTION (optimize) < 2)
     return true;
 
   get_inner_reference_aff (mem1->mem.ref, &off1, &size1);
@@ -2422,7 +2422,7 @@ tree_ssa_lim_initialize (void)
   gcc_obstack_init (&mem_ref_obstack);
   lim_aux_data_map = pointer_map_create ();
 
-  if (flag_tm)
+  if (GCC_OPTION (flag_tm))
     compute_transaction_bits ();
 
   alloc_aux_for_edges (0);
@@ -2541,7 +2541,7 @@ tree_ssa_loop_im (void)
 static bool
 gate_tree_ssa_loop_im (void)
 {
-  return flag_tree_loop_im != 0;
+  return GCC_OPTION (flag_tree_loop_im) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-loop-ivcanon.c b/gcc/tree-ssa-loop-ivcanon.c
index b475b06..bddbdfc 100644
--- a/gcc/tree-ssa-loop-ivcanon.c
+++ b/gcc/tree-ssa-loop-ivcanon.c
@@ -1146,7 +1146,7 @@ tree_unroll_loops_completely_1 (bool may_increase_size, bool unroll_outer,
     ul = UL_NO_GROWTH;
 
   if (canonicalize_loop_induction_variables
-        (loop, false, ul, !flag_tree_loop_ivcanon))
+        (loop, false, ul, !GCC_OPTION (flag_tree_loop_ivcanon)))
     {
       /* If we'll continue unrolling, we need to propagate constants
 	 within the new basic blocks to fold away induction variable
@@ -1268,7 +1268,7 @@ tree_ssa_loop_ivcanon (void)
 static bool
 gate_tree_ssa_loop_ivcanon (void)
 {
-  return flag_tree_loop_ivcanon != 0;
+  return GCC_OPTION (flag_tree_loop_ivcanon) != 0;
 }
 
 namespace {
@@ -1317,9 +1317,9 @@ tree_complete_unroll (void)
   if (number_of_loops (cfun) <= 1)
     return 0;
 
-  return tree_unroll_loops_completely (flag_unroll_loops
-				       || flag_peel_loops
-				       || optimize >= 3, true);
+  return tree_unroll_loops_completely (GCC_OPTION (flag_unroll_loops)
+				       || GCC_OPTION (flag_peel_loops)
+				       || GCC_OPTION (optimize) >= 3, true);
 }
 
 static bool
@@ -1378,7 +1378,7 @@ tree_complete_unroll_inner (void)
   if (number_of_loops (cfun) > 1)
     {
       scev_initialize ();
-      ret = tree_unroll_loops_completely (optimize >= 3, false);
+      ret = tree_unroll_loops_completely (GCC_OPTION (optimize) >= 3, false);
       free_numbers_of_iterations_estimates ();
       scev_finalize ();
     }
@@ -1390,7 +1390,7 @@ tree_complete_unroll_inner (void)
 static bool
 gate_tree_complete_unroll_inner (void)
 {
-  return optimize >= 2;
+  return GCC_OPTION (optimize) >= 2;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-loop-niter.c b/gcc/tree-ssa-loop-niter.c
index 7628363..bd3d740 100644
--- a/gcc/tree-ssa-loop-niter.c
+++ b/gcc/tree-ssa-loop-niter.c
@@ -1983,7 +1983,7 @@ number_of_iterations_exit (struct loop *loop, edge exit,
       return false;
     }
 
-  if (optimize >= 3)
+  if (GCC_OPTION (optimize) >= 3)
     {
       niter->assumptions = simplify_using_outer_evolutions (loop,
 							    niter->assumptions);
@@ -2014,7 +2014,7 @@ number_of_iterations_exit (struct loop *loop, edge exit,
   if (integer_zerop (niter->assumptions) || !single_exit (loop))
     return false;
 
-  if (flag_unsafe_loop_optimizations)
+  if (GCC_OPTION (flag_unsafe_loop_optimizations))
     niter->assumptions = boolean_true_node;
 
   if (warn)
@@ -2029,12 +2029,12 @@ number_of_iterations_exit (struct loop *loop, edge exit,
 	     && (integer_onep (iv1.step) || integer_all_onesp (iv1.step)))
 	  : (integer_onep (iv0.step) || integer_all_onesp (iv0.step)))
         wording =
-          flag_unsafe_loop_optimizations
+          GCC_OPTION (flag_unsafe_loop_optimizations)
           ? N_("assuming that the loop is not infinite")
           : N_("cannot optimize possibly infinite loops");
       else
 	wording =
-	  flag_unsafe_loop_optimizations
+	  GCC_OPTION (flag_unsafe_loop_optimizations)
 	  ? N_("assuming that the loop counter does not overflow")
 	  : N_("cannot optimize loop, the loop counter may overflow");
 
@@ -2042,7 +2042,7 @@ number_of_iterations_exit (struct loop *loop, edge exit,
 		  OPT_Wunsafe_loop_optimizations, "%s", gettext (wording));
     }
 
-  return flag_unsafe_loop_optimizations;
+  return GCC_OPTION (flag_unsafe_loop_optimizations);
 }
 
 /* Try to determine the number of iterations of LOOP.  If we succeed,
@@ -2118,7 +2118,7 @@ finite_loop_p (struct loop *loop)
   double_int nit;
   int flags;
 
-  if (flag_unsafe_loop_optimizations)
+  if (GCC_OPTION (flag_unsafe_loop_optimizations))
     return true;
   flags = flags_from_decl_or_type (current_function_decl);
   if ((flags & (ECF_CONST|ECF_PURE)) && !(flags & ECF_LOOPING_CONST_OR_PURE))
@@ -2396,7 +2396,7 @@ find_loop_niter_by_eval (struct loop *loop, edge *exit)
   *exit = NULL;
 
   /* Loops with multiple exits are expensive to handle and less important.  */
-  if (!flag_expensive_optimizations
+  if (!GCC_OPTION (flag_expensive_optimizations)
       && exits.length () > 1)
     {
       exits.release ();
@@ -2610,7 +2610,7 @@ do_warn_aggressive_loop_optimizations (struct loop *loop,
   /* Don't warn if the loop doesn't have known constant bound.  */
   if (!loop->nb_iterations
       || TREE_CODE (loop->nb_iterations) != INTEGER_CST
-      || !warn_aggressive_loop_optimizations
+      || !GCC_OPTION (warn_aggressive_loop_optimizations)
       /* To avoid warning multiple times for the same loop,
 	 only start warning when we preserve loops.  */
       || (cfun->curr_properties & PROP_loops) == 0
@@ -2974,7 +2974,7 @@ infer_loop_bounds_from_pointer_arith (struct loop *loop, gimple stmt)
      NULL pointer since that would mean wrapping, which we assume here not to
      happen.  So, we can exclude NULL from the valid range of pointer
      arithmetic.  */
-  if (flag_delete_null_pointer_checks && int_cst_value (low) == 0)
+  if (GCC_OPTION (flag_delete_null_pointer_checks) && int_cst_value (low) == 0)
     low = build_int_cstu (TREE_TYPE (low), TYPE_ALIGN_UNIT (TREE_TYPE (type)));
 
   record_nonwrapping_iv (loop, base, step, stmt, low, high, false, true);
@@ -3437,7 +3437,7 @@ estimate_numbers_of_iterations_loop (struct loop *loop)
     }
   exits.release ();
 
-  if (flag_aggressive_loop_optimizations)
+  if (GCC_OPTION (flag_aggressive_loop_optimizations))
     infer_loop_bounds_from_undefined (loop);
 
   discover_iteration_bound_by_body_walk (loop);
diff --git a/gcc/tree-ssa-loop-prefetch.c b/gcc/tree-ssa-loop-prefetch.c
index c0968c8..333fcaf 100644
--- a/gcc/tree-ssa-loop-prefetch.c
+++ b/gcc/tree-ssa-loop-prefetch.c
@@ -2016,7 +2016,7 @@ tree_ssa_loop_prefetch (void)
 static bool
 gate_tree_ssa_loop_prefetch (void)
 {
-  return flag_prefetch_loop_arrays > 0;
+  return GCC_OPTION (flag_prefetch_loop_arrays) > 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-loop-unswitch.c b/gcc/tree-ssa-loop-unswitch.c
index 5031378..55027e4 100644
--- a/gcc/tree-ssa-loop-unswitch.c
+++ b/gcc/tree-ssa-loop-unswitch.c
@@ -414,7 +414,7 @@ tree_ssa_loop_unswitch (void)
 static bool
 gate_tree_ssa_loop_unswitch (void)
 {
-  return flag_unswitch_loops != 0;
+  return GCC_OPTION (flag_unswitch_loops) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-loop.c b/gcc/tree-ssa-loop.c
index e71519a..7048309 100644
--- a/gcc/tree-ssa-loop.c
+++ b/gcc/tree-ssa-loop.c
@@ -47,7 +47,7 @@ along with GCC; see the file COPYING3.  If not see
 static bool
 gate_tree_loop (void)
 {
-  return flag_tree_loop_optimize != 0;
+  return GCC_OPTION (flag_tree_loop_optimize) != 0;
 }
 
 namespace {
@@ -157,7 +157,7 @@ tree_loop_vectorize (void)
 static bool
 gate_tree_loop_vectorize (void)
 {
-  return flag_tree_loop_vectorize || cfun->has_force_vect_loops;
+  return GCC_OPTION (flag_tree_loop_vectorize) || cfun->has_force_vect_loops;
 }
 
 namespace {
@@ -213,7 +213,7 @@ check_data_deps (void)
 static bool
 gate_check_data_deps (void)
 {
-  return flag_check_data_deps != 0;
+  return GCC_OPTION (flag_check_data_deps) != 0;
 }
 
 namespace {
@@ -259,7 +259,7 @@ make_pass_check_data_deps (gcc::context *ctxt)
 static bool
 gate_scev_const_prop (void)
 {
-  return flag_tree_scev_cprop;
+  return GCC_OPTION (flag_tree_scev_cprop);
 }
 
 namespace {
@@ -366,7 +366,7 @@ tree_ssa_loop_ivopts (void)
 static bool
 gate_tree_ssa_loop_ivopts (void)
 {
-  return flag_ivopts != 0;
+  return GCC_OPTION (flag_ivopts) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-math-opts.c b/gcc/tree-ssa-math-opts.c
index 9ff857c..e451974 100644
--- a/gcc/tree-ssa-math-opts.c
+++ b/gcc/tree-ssa-math-opts.c
@@ -316,7 +316,7 @@ compute_merit (struct occurrence *occ)
       if (occ_child->children)
         compute_merit (occ_child);
 
-      if (flag_exceptions)
+      if (GCC_OPTION (flag_exceptions))
 	bb = single_noncomplex_succ (dom);
       else
 	bb = dom;
@@ -359,7 +359,7 @@ insert_reciprocals (gimple_stmt_iterator *def_gsi, struct occurrence *occ,
   struct occurrence *occ_child;
 
   if (!recip_def
-      && (occ->bb_has_division || !flag_trapping_math)
+      && (occ->bb_has_division || !GCC_OPTION (flag_trapping_math))
       && occ->num_divisions >= threshold)
     {
       /* Make a variable with the replacement and substitute it.  */
@@ -507,7 +507,7 @@ execute_cse_reciprocals_1 (gimple_stmt_iterator *def_gsi, tree def)
 static bool
 gate_cse_reciprocals (void)
 {
-  return optimize && flag_reciprocal_math;
+  return GCC_OPTION (optimize) && GCC_OPTION (flag_reciprocal_math);
 }
 
 /* Go through all the floating-point SSA_NAMEs, and call
@@ -1161,7 +1161,7 @@ gimple_expand_builtin_pow (gimple_stmt_iterator *gsi, location_t loc,
 
   if (c_is_int
       && ((n >= -1 && n <= 2)
-	  || (flag_unsafe_math_optimizations
+	  || (GCC_OPTION (flag_unsafe_math_optimizations)
 	      && optimize_insn_for_speed_p ()
 	      && powi_cost (n) <= POWI_MAX_MULTS)))
     return gimple_expand_builtin_powi (gsi, loc, arg0, n);
@@ -1187,7 +1187,7 @@ gimple_expand_builtin_pow (gimple_stmt_iterator *gsi, location_t loc,
   SET_REAL_EXP (&dconst1_4, REAL_EXP (&dconst1_4) - 2);
   hw_sqrt_exists = optab_handler (sqrt_optab, mode) != CODE_FOR_nothing;
 
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && sqrtfn
       && REAL_VALUES_EQUAL (c, dconst1_4)
       && hw_sqrt_exists)
@@ -1205,7 +1205,7 @@ gimple_expand_builtin_pow (gimple_stmt_iterator *gsi, location_t loc,
   real_from_integer (&dconst3_4, VOIDmode, 3, 0, 0);
   SET_REAL_EXP (&dconst3_4, REAL_EXP (&dconst3_4) - 2);
 
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && sqrtfn
       && optimize_function_for_speed_p (cfun)
       && REAL_VALUES_EQUAL (c, dconst3_4)
@@ -1231,7 +1231,7 @@ gimple_expand_builtin_pow (gimple_stmt_iterator *gsi, location_t loc,
   cbrtfn = mathfn_built_in (type, BUILT_IN_CBRT);
   dconst1_3 = real_value_truncate (mode, dconst_third ());
 
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && cbrtfn
       && (gimple_val_nonnegative_real_p (arg0) || !HONOR_NANS (mode))
       && REAL_VALUES_EQUAL (c, dconst1_3))
@@ -1242,7 +1242,7 @@ gimple_expand_builtin_pow (gimple_stmt_iterator *gsi, location_t loc,
   dconst1_6 = dconst1_3;
   SET_REAL_EXP (&dconst1_6, REAL_EXP (&dconst1_6) - 1);
 
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && sqrtfn
       && cbrtfn
       && (gimple_val_nonnegative_real_p (arg0) || !HONOR_NANS (mode))
@@ -1269,7 +1269,7 @@ gimple_expand_builtin_pow (gimple_stmt_iterator *gsi, location_t loc,
   real_from_integer (&cint, VOIDmode, n, n < 0 ? -1 : 0, 0);
   c2_is_int = real_identical (&c2, &cint);
 
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && sqrtfn
       && c2_is_int
       && !c_is_int
@@ -1322,7 +1322,7 @@ gimple_expand_builtin_pow (gimple_stmt_iterator *gsi, location_t loc,
   real_arithmetic (&c2, RDIV_EXPR, &cint, &dconst3);
   real_convert (&c2, mode, &c2);
 
-  if (flag_unsafe_math_optimizations
+  if (GCC_OPTION (flag_unsafe_math_optimizations)
       && cbrtfn
       && (gimple_val_nonnegative_real_p (arg0) || !HONOR_NANS (mode))
       && real_identical (&c2, &c)
@@ -1386,7 +1386,7 @@ gimple_expand_builtin_cabs (gimple_stmt_iterator *gsi, location_t loc, tree arg)
   tree sqrtfn = mathfn_built_in (type, BUILT_IN_SQRT);
   enum machine_mode mode = TYPE_MODE (type);
 
-  if (!flag_unsafe_math_optimizations
+  if (!GCC_OPTION (flag_unsafe_math_optimizations)
       || !optimize_bb_for_speed_p (gimple_bb (gsi_stmt (*gsi)))
       || !sqrtfn
       || optab_handler (sqrt_optab, mode) == CODE_FOR_nothing)
@@ -1568,7 +1568,7 @@ gate_cse_sincos (void)
 {
   /* We no longer require either sincos or cexp, since powi expansion
      piggybacks on this pass.  */
-  return optimize;
+  return GCC_OPTION (optimize);
 }
 
 namespace {
@@ -2070,7 +2070,7 @@ execute_optimize_bswap (void)
 static bool
 gate_optimize_bswap (void)
 {
-  return flag_expensive_optimizations && optimize;
+  return GCC_OPTION (flag_expensive_optimizations) && GCC_OPTION (optimize);
 }
 
 namespace {
@@ -2592,7 +2592,7 @@ convert_mult_to_fma (gimple mul_stmt, tree op1, tree op2)
   imm_use_iterator imm_iter;
 
   if (FLOAT_TYPE_P (type)
-      && flag_fp_contract_mode == FP_CONTRACT_OFF)
+      && GCC_OPTION (flag_fp_contract_mode) == FP_CONTRACT_OFF)
     return false;
 
   /* We don't want to do bitfield reduction ops.  */
@@ -2880,7 +2880,7 @@ execute_optimize_widening_mul (void)
 static bool
 gate_optimize_widening_mul (void)
 {
-  return flag_expensive_optimizations && optimize;
+  return GCC_OPTION (flag_expensive_optimizations) && GCC_OPTION (optimize);
 }
 
 namespace {
diff --git a/gcc/tree-ssa-operands.c b/gcc/tree-ssa-operands.c
index 352ccca..8170efa 100644
--- a/gcc/tree-ssa-operands.c
+++ b/gcc/tree-ssa-operands.c
@@ -477,7 +477,7 @@ append_use (tree *use_p)
 static inline void
 append_vdef (tree var)
 {
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return;
 
   gcc_assert ((build_vdef == NULL_TREE
@@ -495,7 +495,7 @@ append_vdef (tree var)
 static inline void
 append_vuse (tree var)
 {
-  if (!optimize)
+  if (!GCC_OPTION (optimize))
     return;
 
   gcc_assert (build_vuse == NULL_TREE
diff --git a/gcc/tree-ssa-phiopt.c b/gcc/tree-ssa-phiopt.c
index 95cf4d4..3514cb4 100644
--- a/gcc/tree-ssa-phiopt.c
+++ b/gcc/tree-ssa-phiopt.c
@@ -349,11 +349,11 @@ tree_ssa_phiopt_worker (bool do_store_elim, bool do_hoist_loads)
   bool replace_conditional_negation = false;
   if (!do_store_elim)
     replace_conditional_negation
-      = ((!optimize_size && optimize >= 2)
-	 || (((flag_tree_loop_vectorize || cfun->has_force_vect_loops)
-	      && flag_tree_loop_if_convert != 0)
-	     || flag_tree_loop_if_convert == 1
-	     || flag_tree_loop_if_convert_stores == 1));
+      = ((!GCC_OPTION (optimize_size) && GCC_OPTION (optimize) >= 2)
+	 || (((GCC_OPTION (flag_tree_loop_vectorize) || cfun->has_force_vect_loops)
+	      && GCC_OPTION (flag_tree_loop_if_convert) != 0)
+	     || GCC_OPTION (flag_tree_loop_if_convert) == 1
+	     || GCC_OPTION (flag_tree_loop_if_convert_stores) == 1));
 
   /* Search every basic block for COND_EXPR we may be able to optimize.
 
@@ -2195,7 +2195,7 @@ hoist_adjacent_loads (basic_block bb0, basic_block bb1,
 static bool
 gate_hoist_loads (void)
 {
-  return (flag_hoist_adjacent_loads == 1
+  return (GCC_OPTION (flag_hoist_adjacent_loads) == 1
 	  && PARAM_VALUE (PARAM_L1_CACHE_LINE_SIZE)
 	  && HAVE_conditional_move);
 }
@@ -2251,7 +2251,7 @@ make_pass_phiopt (gcc::context *ctxt)
 static bool
 gate_cselim (void)
 {
-  return flag_tree_cselim;
+  return GCC_OPTION (flag_tree_cselim);
 }
 
 namespace {
diff --git a/gcc/tree-ssa-phiprop.c b/gcc/tree-ssa-phiprop.c
index 4d66c12..e1059e7 100644
--- a/gcc/tree-ssa-phiprop.c
+++ b/gcc/tree-ssa-phiprop.c
@@ -412,7 +412,7 @@ tree_ssa_phiprop (void)
 static bool
 gate_phiprop (void)
 {
-  return flag_tree_phiprop;
+  return GCC_OPTION (flag_tree_phiprop);
 }
 
 namespace {
diff --git a/gcc/tree-ssa-pre.c b/gcc/tree-ssa-pre.c
index 1e55356..6e7d8d7 100644
--- a/gcc/tree-ssa-pre.c
+++ b/gcc/tree-ssa-pre.c
@@ -3027,7 +3027,7 @@ inhibit_phi_insertion (basic_block bb, pre_expr expr)
   unsigned i;
 
   /* If we aren't going to vectorize we don't inhibit anything.  */
-  if (!flag_tree_loop_vectorize)
+  if (!GCC_OPTION (flag_tree_loop_vectorize))
     return false;
 
   /* Otherwise we inhibit the insertion when the address of the
@@ -4709,7 +4709,7 @@ do_pre (void)
   unsigned int todo = 0;
 
   do_partial_partial =
-    flag_tree_partial_pre && optimize_function_for_speed_p (cfun);
+    GCC_OPTION (flag_tree_partial_pre) && optimize_function_for_speed_p (cfun);
 
   /* This has to happen before SCCVN runs because
      loop_optimizer_init may create new phis, etc.  */
@@ -4785,7 +4785,7 @@ do_pre (void)
 static bool
 gate_pre (void)
 {
-  return flag_tree_pre != 0;
+  return GCC_OPTION (flag_tree_pre) != 0;
 }
 
 namespace {
@@ -4857,7 +4857,7 @@ execute_fre (void)
 static bool
 gate_fre (void)
 {
-  return flag_tree_fre != 0;
+  return GCC_OPTION (flag_tree_fre) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-reassoc.c b/gcc/tree-ssa-reassoc.c
index e9e29e5..0df0e58 100644
--- a/gcc/tree-ssa-reassoc.c
+++ b/gcc/tree-ssa-reassoc.c
@@ -3649,7 +3649,7 @@ acceptable_pow_call (gimple stmt, tree *base, HOST_WIDE_INT *exponent)
   REAL_VALUE_TYPE c, cint;
 
   if (!first_pass_instance
-      || !flag_unsafe_math_optimizations
+      || !GCC_OPTION (flag_unsafe_math_optimizations)
       || !is_gimple_call (stmt)
       || !has_single_use (gimple_call_lhs (stmt)))
     return false;
@@ -3925,7 +3925,7 @@ can_reassociate_p (tree op)
   tree type = TREE_TYPE (op);
   if ((INTEGRAL_TYPE_P (type) && TYPE_OVERFLOW_WRAPS (type))
       || NON_SAT_FIXED_POINT_TYPE_P (type)
-      || (flag_associative_math && FLOAT_TYPE_P (type)))
+      || (GCC_OPTION (flag_associative_math) && FLOAT_TYPE_P (type)))
     return true;
   return false;
 }
@@ -4473,7 +4473,7 @@ reassociate_bb (basic_block bb)
 
 	      if (first_pass_instance
 		  && rhs_code == MULT_EXPR
-		  && flag_unsafe_math_optimizations)
+		  && GCC_OPTION (flag_unsafe_math_optimizations))
 		powi_result = attempt_builtin_powi (stmt, &ops);
 
 	      /* If the operand vector is now empty, all operands were 
@@ -4668,7 +4668,7 @@ execute_reassoc (void)
 static bool
 gate_tree_ssa_reassoc (void)
 {
-  return flag_tree_reassoc != 0;
+  return GCC_OPTION (flag_tree_reassoc) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-sccvn.c b/gcc/tree-ssa-sccvn.c
index f7ec8b6..e2038f6 100644
--- a/gcc/tree-ssa-sccvn.c
+++ b/gcc/tree-ssa-sccvn.c
@@ -4239,8 +4239,8 @@ vn_nary_may_trap (vn_nary_op_t nary)
       fp_operation = FLOAT_TYPE_P (type);
       if (fp_operation)
 	{
-	  honor_nans = flag_trapping_math && !flag_finite_math_only;
-	  honor_snans = flag_signaling_nans != 0;
+	  honor_nans = GCC_OPTION (flag_trapping_math) && !GCC_OPTION (flag_finite_math_only);
+	  honor_snans = GCC_OPTION (flag_signaling_nans) != 0;
 	}
       else if (INTEGRAL_TYPE_P (type)
 	       && TYPE_OVERFLOW_TRAPS (type))
diff --git a/gcc/tree-ssa-sink.c b/gcc/tree-ssa-sink.c
index 6d02975..9564e50 100644
--- a/gcc/tree-ssa-sink.c
+++ b/gcc/tree-ssa-sink.c
@@ -591,7 +591,7 @@ do_sink (void)
 static bool
 gate_sink (void)
 {
-  return flag_tree_sink != 0;
+  return GCC_OPTION (flag_tree_sink) != 0;
 }
 
 namespace {
diff --git a/gcc/tree-ssa-strlen.c b/gcc/tree-ssa-strlen.c
index f55b7ee..6f7aecd 100644
--- a/gcc/tree-ssa-strlen.c
+++ b/gcc/tree-ssa-strlen.c
@@ -2092,7 +2092,7 @@ tree_ssa_strlen (void)
 static bool
 gate_strlen (void)
 {
-  return flag_optimize_strlen != 0;
+  return GCC_OPTION (flag_optimize_strlen) != 0;
 }
 
 namespace {
